#pragma once

#include "SubCondition.h"
#include "WTextFile.h"
#include <afxtempl.h>
#include "InputError.h"


class OrSubCondition : public SubCondition
{
public:
	DECLARE_SERIAL( OrSubCondition )

	OrSubCondition(void){};
	OrSubCondition( int col, int comp, double refValue );
	OrSubCondition( int col, int comp, CString refValueText );
	OrSubCondition( OrSubCondition *copyOrSubCondition);
	~OrSubCondition(void);

	void addSubCondition(int column, int comparator, double referenceValue);
	void addSubCondition(int column, int comparator, CString referenceValueText);
	void insertSubCondition(int where, int column, int comparator, double referenceValue);
	void insertSubCondition(int where, int column, int comparator, CString referenceValueText);
	void deleteLastSubCondition();
	void deleteSubCondition( int where );
	int replaceSubCondition(int subCondNumber, int column, int comparator,
		double referenceValue, int referenceType);
	int replaceSubCondition(int subCondNumber, int column, int comparator,
		CString referenceValueText, int referenceType);
	virtual BOOL check(WTextFile *theTextFile, int lineNumber);
	int returnColumn(int subCondNumber);
	int returnComparator(int subCondNumber);
	int returnReferenceType( int subCondNumber);
	double returnReferenceValue(int subCondNumber);
	CString returnReferenceValueText(int subCondNumber);
	int returnSize( );
	SubCondition *at( int index );

	virtual void Serialize( CArchive& archive );
	virtual InputError checkValidInputs( WTextFile * theTextFile );

public:
	CArray<SubCondition *> subConditions;
};

